-- Priority List 3
-- by Jadya
-- EU-Well of Eternity

local addonName, addonTable = ...
local L = addonTable.L

local tsort, lower = table.sort, string.lower

local addon = PriorityList
local menus = addon.MenuFunctions
local constructors = addon.Constructors

-- dropdowns' custom menu frame
local dd_num_elements = 10
local dd_menuframe

local function listUpdate(self)
 local offset  = HybridScrollFrame_GetOffset(self)
 local buttons = self.buttons
 local height  = 15

 local list = dd_menuframe.elements
  for i = 1, #buttons do
  local index = offset + i
  if list[index] then
   local s1,s2 = strsplit("#", list[index])
   buttons[i].icon:SetTexture(0,0,1,1)
   buttons[i].s_left:SetText(s1)
   buttons[i].s_right:SetText(addonTable.AddColor(s2, "LIGHT_GREEN"))
   buttons[i]:Show()
  else
   buttons[i]:Hide()
  end
 end
 
 HybridScrollFrame_Update(self, height * #list, height)
end

function menus:PopupInit(p)
 dd_menuframe = CreateFrame("Frame", "PLDDPopupMenuframe", p)
 dd_menuframe:SetFrameStrata("DIALOG")
 dd_menuframe.elements = {}
 dd_menuframe:SetPoint("CENTER")
 dd_menuframe:SetSize(50,150)
 dd_menuframe:SetBackdrop(constructors.frame_backdrop)
 dd_menuframe:SetBackdropColor(0,0,0,1)
 dd_menuframe:SetBackdropBorderColor(0.1,0.3,0.4,1)
 dd_menuframe.container = constructors:PopupListBox(dd_menuframe, "PLPopupMenuFrameScrollFrame", 0, 0, 0, 0, "PLPopupMenuButtonTemplate", listUpdate)
 dd_menuframe.container:SetScript("OnMouseUp", menus.PopupHide)
 dd_menuframe:Hide()
end

function menus.PopupShow(dd)
 if not dd.elements or (dd_menuframe.base_elements == dd.elements and dd_menuframe:IsVisible()) then 
  menus:PopupHide()
  return
 end

 wipe(dd_menuframe.elements)
 local i = 0
 for k in pairs(dd.elements) do
  i = i + 1
  dd_menuframe.elements[i] = k.."#"..(dd.func_righttext and dd.func_righttext(k) or "")
 end

 if i == 0 then
  menus:PopupHide()
  return
 end
 
 tsort(dd_menuframe.elements, function(a,b) return lower(a) < lower(b) end)
 dd_menuframe:SetSize(dd:GetWidth(), math.min(#(dd_menuframe.elements) * 15, 150))
 dd_menuframe:SetPoint("TOPLEFT", dd, "BOTTOMLEFT")
 dd_menuframe.container.dd = dd
 dd_menuframe.container:update()
 dd_menuframe.base_elements = dd.elements
 dd:SetBackdropBorderColor(0.1,0.9,0.2,1)
 dd_menuframe:Show()
end

function menus:PopupHide()
 if dd_menuframe.container.dd then
  dd_menuframe.container.dd:SetBackdropBorderColor(0.1,0.3,0.4,1)
 end
 dd_menuframe:Hide()
end

-- wishlist/looted tab character
local personal_list = {}
function menus.Init_CharSelect(dd)

 local function onClick(arg)
  addon:EventPulse("select_char", arg)
  addon:Refresh()
 end

 local function count(name)
  return #(PLWish_List[name][addon.sel_difficulty].lists[addon.sel_list])
 end

 dd.func = onClick
 dd.func_righttext = count
 dd.elements = PLWish_List
end

-- import tab list
function menus.Init_ImportSender(dd, level, menuList)

 local function onClick(arg)
  addon:EventPulse("select_import_sender", arg)
  addon:Refresh()
 end

 dd.func = onClick
 dd.elements = addon.import_list
end

-- import tab list
function menus.Init_ImportChar(dd, level, menuList)

 local function onClick(arg)
  addon:EventPulse("select_import_char", arg)
  addon:Refresh()
 end

 dd.func = onClick
end